VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "Phidget Monitor"
   ClientHeight    =   3885
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5535
   LinkTopic       =   "Form1"
   ScaleHeight     =   3885
   ScaleWidth      =   5535
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView lvStatus 
      Height          =   2595
      Left            =   0
      TabIndex        =   0
      Top             =   240
      Width           =   5535
      _ExtentX        =   9763
      _ExtentY        =   4577
      View            =   3
      Sorted          =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.Label lblLibraryVersion 
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   3360
      Width           =   5295
   End
   Begin VB.Label Label1 
      Caption         =   "Library Information"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   3000
      Width           =   2055
   End
   Begin VB.Label lblStatus 
      Caption         =   "Status"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Program:     PhidgetMonitor
' Description:
' - List all attached phidgets and error messages
' - If a previously seen phidget is detached, it is kept on the list
'   but its attached state is displayed as False
' What it shows you:
' - How to use the PhidgetManager to track devices
' - How to use the PHIDGET.IPhidget object to ask questons about that device

Option Explicit
Private WithEvents PM As PhidgetManager
Attribute PM.VB_VarHelpID = -1


Private Sub Form_Load()

    ' Ugly Hack to show the Library info if no phidgets are attached
    Dim Temp As PhidgetInterfaceKit
    Dim Count
    Set Temp = Controls.Add("Phidget21COM.PhidgetInterfaceKit", "Temp")
    lblLibraryVersion.Caption = Temp.LibraryVersion

    'Set up the lists where we will display our phidget state
    DisplayInitialize
    
    'Get the phidget manager going
    Set PM = Controls.Add("Phidget21COM.PhidgetManager", "PM")
    PM.Open

    'If (PM.IsAttachedToServer = False) Then
    '    MsgBox "Couldn't Connect to Remote Phidget Manager"
    '    Unload Form1
    '    End
    'End If
    
    Count = PM.Count
End Sub

Private Sub PM_OnAttach(ByVal deviceType As String, ByVal deviceName As String, ByVal serialNumber As Long, ByVal version As Long, ByVal tag As String)
    DisplayDevice deviceName, version, serialNumber, True
End Sub

Private Sub DisplayInitialize()
    Dim Divisions As Integer
   
    'Initialize the listview and properties (we could do this in the properties window instead)
    lvStatus.Sorted = True
    lvStatus.SortKey = 0
    lvStatus.SortOrder = lvwAscending
    lvStatus.View = lvwReport
    lvStatus.GridLines = True
   
    'Initialize the listview headers and column widths
    Divisions = 6
    lvStatus.ColumnHeaders.Add 1, , "Device Type", 3 * (lvStatus.Width / Divisions)
    lvStatus.ColumnHeaders.Add 2, , "Serial #", 1 * (lvStatus.Width / Divisions)
    lvStatus.ColumnHeaders.Add 3, , "Version", 1 * (lvStatus.Width / Divisions)
    lvStatus.ColumnHeaders.Add 4, , "Attached", 1 * (lvStatus.Width / Divisions)
End Sub

'Add or change a row in the listview to describe the phidget state
Private Sub DisplayDevice(deviceName As String, version As Long, serialNumber As Long, Attached As Boolean)
    Dim L As ListItem
    Dim Found As Boolean
    
    Found = False                        'Is this particular phidget already in the list?
    For Each L In lvStatus.ListItems
        If L.Text & L.SubItems(1) = deviceName & serialNumber Then
            Found = True                 'Yup, it is.
            Exit For
        End If
    Next L
    
    'If this particular phidget is not in the list, add it.
    If Found = False Then
        Set L = lvStatus.ListItems.Add(1, , deviceName)
        L.SubItems(1) = CStr(serialNumber)
        L.SubItems(2) = CStr(version)
        
    End If
    L.SubItems(3) = CStr(Attached)
    L.Bold = Attached  'Bold the phidget if it is attached
End Sub

Private Sub PM_OnDetach(ByVal deviceType As String, ByVal deviceName As String, ByVal serialNumber As Long, ByVal version As Long, ByVal tag As String)
    DisplayDevice deviceName, version, serialNumber, False
End Sub

Private Sub PM_OnError(ByVal Description As String, ByVal SCODE As Long)

        MsgBox Description
        Unload Form1
        End
End Sub
